//+-------------------------------------------------------------------+
//|                                            FiboFanChanell_v1.mq4  |
//|                                                                   |
//|       Sadhu VChanell_v053.mq4 |
//|    http://onix-trade.net/forum                            |
//+-------------------------------------------------------------------+
//|                                                                   |
//|Complect -    .                  |   
//|timeframe -                     |
//|(1,5,15,30,60,240,1440,10080,43200)   .      |
//|           | 
//|backgr -     ( )       |
//|.                                                             |
//|over -  true   timeframe   0,    |
//|      timeframe,        |
//| .                                                   |
//|save_fan -               |
//|.                                                        |
//|stopper -             | 
//|.                                                              |
//|delpoints -        .   |
//|col -   .                                        |
//|style -    (,    ..).     |
//|width -    .                              |
//|handycode -  false,      ,  |
//|   (Complect).                        |
//|code -       (handycode=true).   |
//|fplace -     1-    .|
//|splace -     2-    .|
//|                                                                   |
//|-------------------------------------------------------------------|
#property copyright ""
#property link      ""

#property indicator_chart_window

//---- input parameters
extern int Complect=11;
extern int timeframe=1440;
extern bool FiboTime=true;
extern bool backgr=true;
extern bool over=true;
extern bool save_fan=false;
extern bool stopper=true;
extern bool delpoints=true;
extern color col=Olive;
extern int style=0;
extern int width=2;
extern color timecol=Gainsboro;
extern int timestyle=1;
extern int timewidth=1;
extern bool handycode=false;
extern int code=108;
extern int fplace=33;
extern int splace=1;
//---- buffers

datetime prevtime;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   ObjectDelete("FiboFanU Complect"+Complect);
   ObjectDelete("FiboFanD Complect"+Complect);
   if(FiboTime) ObjectDelete("FiboTime Complect"+Complect);
//----
   return(0);
 } 
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----    
   if(delpoints)
    {
     ObjectDelete("Point1 Complect"+Complect);
     ObjectDelete("Point2 Complect"+Complect);
    } 
   if(!save_fan)
    {
     ObjectDelete("FiboFanU Complect"+Complect);
     ObjectDelete("FiboFanD Complect"+Complect);
    }
   if(FiboTime) ObjectDelete("FiboTime Complect"+Complect);                  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int error=GetLastError();
//----
   if(stopper)
    {
     if(prevtime == Time[0]) return(0);
     if(error!=4066) prevtime = Time[0];
    } 
//----   
   int P, nP1, nP2, nH, nL, nPoint2, nPoint1, a ;
   int pointcode;
   double period;
   bool up;
   datetime Date1;
   datetime Date2;
//----
   if(style<0 || style>4) style=0;
//----   
   ObjectDelete("FiboFanU Complect"+Complect);
   ObjectDelete("FiboFanD Complect"+Complect);
//----   
   if(FiboTime) ObjectDelete("FiboTime Complect"+Complect);
//----
   switch (timeframe)
    {
      case 1:
         period = OBJ_PERIOD_M1;
         break;
      case 5:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5; else period = OBJ_PERIOD_M5;
         break;
      case 15:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15; else period = OBJ_PERIOD_M15;
         break;
      case 30:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30; else period = OBJ_PERIOD_M30;
         break;      
      case 60:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1; else period = OBJ_PERIOD_H1;
         break;
      case 240:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4; else period = OBJ_PERIOD_H4;
         break;
      case 1440:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4 | OBJ_PERIOD_D1; else period = OBJ_PERIOD_D1;
         break;
      case 10080:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4 | OBJ_PERIOD_D1 | OBJ_PERIOD_W1; else period = OBJ_PERIOD_W1;
         break;
      case 43200:
         period = OBJ_PERIOD_MN1;
         break;
      case 0:
         period = NULL;
         break;
      case -1:
         period = EMPTY;
         break;       
    }   
//---- 
   if(handycode) pointcode=code;
   else
    {
     switch (Complect)
      {
       case  0: pointcode = 139; break;
       case  1: pointcode = 140; break;
       case  2: pointcode = 141; break;
       case  3: pointcode = 142; break;
       case  4: pointcode = 143; break;
       case  5: pointcode = 144; break;
       case  6: pointcode = 145; break;
       case  7: pointcode = 146; break;
       case  8: pointcode = 147; break;
       case  9: pointcode = 148; break;
       case 10: pointcode = 149; break;
       case 11: pointcode = 128; break;
       case 12: pointcode = 129; break;
       case 13: pointcode = 130; break;
       case 14: pointcode = 131; break;
       case 15: pointcode = 132; break;
       case 16: pointcode = 133; break;
       case 17: pointcode = 134; break;
       case 18: pointcode = 135; break;
       case 19: pointcode = 136; break;
       case 20: pointcode = 137; break;
       case 21: pointcode = 138; break;
       default: pointcode = code;
      }
    }   
//----
   if(ObjectFind("Point1 Complect"+Complect)!=0) ObjectCreate("Point1 Complect"+Complect, OBJ_ARROW, 0, Time[fplace], (High[fplace]+Low[fplace])/2);
   if(ObjectFind("Point2 Complect"+Complect)!=0) ObjectCreate("Point2 Complect"+Complect, OBJ_ARROW, 0, Time[splace], (High[splace]+Low[splace])/2);
//----   
   ObjectSet("Point1 Complect"+Complect,OBJPROP_ARROWCODE,pointcode);
   ObjectSet("Point1 Complect"+Complect,OBJPROP_COLOR,col);
   ObjectSet("Point1 Complect"+Complect,OBJPROP_WIDTH,width);
   ObjectSet("Point1 Complect"+Complect,OBJPROP_BACK,backgr);
   ObjectSet("Point1 Complect"+Complect,OBJPROP_TIMEFRAMES,period);
//----   
   ObjectSet("Point2 Complect"+Complect,OBJPROP_ARROWCODE,pointcode);
   ObjectSet("Point2 Complect"+Complect,OBJPROP_COLOR,col);
   ObjectSet("Point2 Complect"+Complect,OBJPROP_WIDTH,width);
   ObjectSet("Point2 Complect"+Complect,OBJPROP_BACK,backgr);
   ObjectSet("Point2 Complect"+Complect,OBJPROP_TIMEFRAMES,period);
//----    
   Date1=ObjectGet("Point2 Complect"+Complect,OBJPROP_TIME1);
   Date2=ObjectGet("Point1 Complect"+Complect,OBJPROP_TIME1);   
//----  
   nP2=iBarShift(NULL,0,Date1,false);
   nP1=iBarShift(NULL,0,Date2,false);
   if(nP1>nP2)
    {
     P=nP1;
     nP1=nP2;
     nP2=P;
    }
   nH=iHighest(NULL,0,MODE_HIGH,nP2-nP1+1,nP1);
   nL=iLowest(NULL,0,MODE_LOW,nP2-nP1+1,nP1);
   if(nL>nH) up=true;
   else if(nL<nH) up=false;  
   if(up)
    {
     nPoint2=nL;
     nPoint1=nH;
    }
   else
    {
     nPoint2=nH;
     nPoint1=nL;
    }
   if(nPoint2==nPoint1) return(0);     
//----    
   if(up)
    {
     ObjectCreate("FiboFanU Complect"+Complect,OBJ_FIBOFAN,0,Time[nPoint2],Low[nPoint2],Time[nPoint1],High[nPoint1]);
     ObjectSet("FiboFanU Complect"+Complect,OBJPROP_TIMEFRAMES,period);
     ObjectSet("FiboFanU Complect"+Complect,OBJPROP_LEVELCOLOR,col);
     ObjectSet("FiboFanU Complect"+Complect,OBJPROP_LEVELSTYLE,style);
     ObjectSet("FiboFanU Complect"+Complect,OBJPROP_LEVELWIDTH,width);
     ObjectSet("FiboFanU Complect"+Complect,OBJPROP_FIBOLEVELS,3);
     
     ObjectSet("FiboFanU Complect"+Complect,OBJPROP_FIRSTLEVEL+0,0.764);
     ObjectSetFiboDescription("FiboFanU Complect"+Complect, 0, "38.2 ch");
     
     ObjectSet("FiboFanU Complect"+Complect,OBJPROP_FIRSTLEVEL+1,1.236);
     ObjectSetFiboDescription("FiboFanU Complect"+Complect, 1, "--38.2 ch");
     
     ObjectSet("FiboFanU Complect"+Complect,OBJPROP_FIRSTLEVEL+2,1.0);
     ObjectSetFiboDescription("FiboFanU Complect"+Complect, 2, "0");
     
 //----
  if(FiboTime)
  {
     ObjectCreate("FiboTime Complect"+Complect,OBJ_FIBOTIMES,0,Time[nPoint2],nPoint2,Time[nPoint1],nPoint1);
     ObjectSet("FiboTime Complect"+Complect,OBJPROP_TIMEFRAMES,period);
     ObjectSet("FiboTime Complect"+Complect,OBJPROP_LEVELCOLOR,timecol);
     ObjectSet("FiboTime Complect"+Complect,OBJPROP_LEVELSTYLE,timestyle);
     ObjectSet("FiboTime Complect"+Complect,OBJPROP_LEVELWIDTH,timewidth);
     ObjectSet("FiboTime Complect"+Complect,OBJPROP_FIBOLEVELS,7);
     
     ObjectSet("FiboTime Complect"+Complect,OBJPROP_FIRSTLEVEL+0,0.618);
     ObjectSetFiboDescription("FiboTime Complect"+Complect, 0, "0.618 Ft");
     
     ObjectSet("FiboTime Complect"+Complect,OBJPROP_FIRSTLEVEL+1,2.0);
     ObjectSetFiboDescription("FiboTime Complect"+Complect, 1, "100 Ft");
     
     ObjectSet("FiboTime Complect"+Complect,OBJPROP_FIRSTLEVEL+2,1.618);
     ObjectSetFiboDescription("FiboTime Complect"+Complect, 2, "61.8 Ft");
     
     ObjectSet("FiboTime Complect"+Complect,OBJPROP_FIRSTLEVEL+3,4.236);
     ObjectSetFiboDescription("FiboTime Complect"+Complect, 3, "423.6 Ft");
     
     ObjectSet("FiboTime Complect"+Complect,OBJPROP_FIRSTLEVEL+4,5.236);
     ObjectSetFiboDescription("FiboTime Complect"+Complect, 4, "523.6 Ft");
     
     ObjectSet("FiboTime Complect"+Complect,OBJPROP_FIRSTLEVEL+5,1.0);
     ObjectSetFiboDescription("FiboTime Complect"+Complect, 5, "0 Ft");
     
      ObjectSet("FiboTime Complect"+Complect,OBJPROP_FIRSTLEVEL+6,2.618);
     ObjectSetFiboDescription("FiboTime Complect"+Complect, 6, "161.8 Ft"); 
     }   
    
     a = 2*nPoint1-nPoint2;
     if(a>=0) ObjectCreate("FiboFanD Complect"+Complect,OBJ_FIBOFAN,0,Time[nPoint1],High[nPoint1],Time[a],Low[nPoint2]);
     else ObjectCreate("FiboFanD Complect"+Complect,OBJ_FIBOFAN,0,Time[nPoint1],High[nPoint1],Time[0]-a*Period()*60,Low[nPoint2]);
     ObjectSet("FiboFanD Complect"+Complect,OBJPROP_TIMEFRAMES,period);
     ObjectSet("FiboFanD Complect"+Complect,OBJPROP_LEVELCOLOR,col);
     ObjectSet("FiboFanD Complect"+Complect,OBJPROP_LEVELSTYLE,style);
     ObjectSet("FiboFanD Complect"+Complect,OBJPROP_LEVELWIDTH,width);
     ObjectSet("FiboFanD Complect"+Complect,OBJPROP_FIBOLEVELS,3);
     
     ObjectSet("FiboFanD Complect"+Complect,OBJPROP_FIRSTLEVEL+0,0.764);
     ObjectSetFiboDescription("FiboFanD Complect"+Complect, 0, "38.2 ch");
     
     ObjectSet("FiboFanD Complect"+Complect,OBJPROP_FIRSTLEVEL+1,1.236);
     ObjectSetFiboDescription("FiboFanD Complect"+Complect, 1, "--38.2 ch");
     
     ObjectSet("FiboFanD Complect"+Complect,OBJPROP_FIRSTLEVEL+2,1.0);
     ObjectSetFiboDescription("FiboFanD Complect"+Complect, 2, "0");
 
//----       
    }
   else
    {
     ObjectCreate("FiboFanU Complect"+Complect,OBJ_FIBOFAN,0,Time[nPoint2],High[nPoint2],Time[nPoint1],Low[nPoint1]);
     ObjectSet("FiboFanU Complect"+Complect,OBJPROP_TIMEFRAMES,period);
     ObjectSet("FiboFanU Complect"+Complect,OBJPROP_LEVELCOLOR,col);
     ObjectSet("FiboFanU Complect"+Complect,OBJPROP_LEVELSTYLE,style);
     ObjectSet("FiboFanU Complect"+Complect,OBJPROP_LEVELWIDTH,width);
     ObjectSet("FiboFanU Complect"+Complect,OBJPROP_FIBOLEVELS,3);
     
     ObjectSet("FiboFanU Complect"+Complect,OBJPROP_FIRSTLEVEL+0,0.764);
     ObjectSetFiboDescription("FiboFanU Complect"+Complect, 0, "38.2 ch");
     
     ObjectSet("FiboFanU Complect"+Complect,OBJPROP_FIRSTLEVEL+1,1.236);
     ObjectSetFiboDescription("FiboFanU Complect"+Complect, 1, "--38.2 ch");
     
     ObjectSet("FiboFanU Complect"+Complect,OBJPROP_FIRSTLEVEL+2,1.0);
     ObjectSetFiboDescription("FiboFanU Complect"+Complect, 2, "0");
//---
     if (FiboTime)
     {
      ObjectCreate("FiboTime Complect"+Complect,OBJ_FIBOTIMES,0,Time[nPoint2],nPoint2,Time[nPoint1],nPoint1);
      ObjectSet("FiboTime Complect"+Complect,OBJPROP_TIMEFRAMES,period);
      ObjectSet("FiboTime Complect"+Complect,OBJPROP_LEVELCOLOR,timecol);
      ObjectSet("FiboTime Complect"+Complect,OBJPROP_LEVELSTYLE,timestyle);
      ObjectSet("FiboTime Complect"+Complect,OBJPROP_LEVELWIDTH,timewidth);
      ObjectSet("FiboTime Complect"+Complect,OBJPROP_FIBOLEVELS,7);
     
      ObjectSet("FiboTime Complect"+Complect,OBJPROP_FIRSTLEVEL+0,0.618);
      ObjectSetFiboDescription("FiboTime Complect"+Complect, 0, "0.618 Ft");
     
      ObjectSet("FiboTime Complect"+Complect,OBJPROP_FIRSTLEVEL+1,2.0);
      ObjectSetFiboDescription("FiboTime Complect"+Complect, 1, "100 Ft");
     
      ObjectSet("FiboTime Complect"+Complect,OBJPROP_FIRSTLEVEL+2,1.618);
      ObjectSetFiboDescription("FiboTime Complect"+Complect, 2, "61.8 Ft");
     
      ObjectSet("FiboTime Complect"+Complect,OBJPROP_FIRSTLEVEL+3,4.236);
      ObjectSetFiboDescription("FiboTime Complect"+Complect, 3, "423.6 Ft");
     
      ObjectSet("FiboTime Complect"+Complect,OBJPROP_FIRSTLEVEL+4,5.236);
      ObjectSetFiboDescription("FiboTime Complect"+Complect, 4, "523.6 Ft");
     
      ObjectSet("FiboTime Complect"+Complect,OBJPROP_FIRSTLEVEL+5,1.0);
      ObjectSetFiboDescription("FiboTime Complect"+Complect, 5, "0 Ft");
     
      ObjectSet("FiboTime Complect"+Complect,OBJPROP_FIRSTLEVEL+6,2.618);
      ObjectSetFiboDescription("FiboTime Complect"+Complect, 6, "161.8 Ft");
     }
     
     a = 2*nPoint1-nPoint2;
         
     if(a>=0) ObjectCreate("FiboFanD Complect"+Complect,OBJ_FIBOFAN,0,Time[nPoint1],Low[nPoint1],Time[a],High[nPoint2]);
     else ObjectCreate("FiboFanD Complect"+Complect,OBJ_FIBOFAN,0,Time[nPoint1],Low[nPoint1],Time[0]-a*Period()*60,High[nPoint2]);
     ObjectSet("FiboFanD Complect"+Complect,OBJPROP_TIMEFRAMES,period);
     ObjectSet("FiboFanD Complect"+Complect,OBJPROP_LEVELCOLOR,col);
     ObjectSet("FiboFanD Complect"+Complect,OBJPROP_LEVELSTYLE,style);
     ObjectSet("FiboFanD Complect"+Complect,OBJPROP_LEVELWIDTH,width);
     ObjectSet("FiboFanD Complect"+Complect,OBJPROP_FIBOLEVELS,3);
     
     ObjectSet("FiboFanD Complect"+Complect,OBJPROP_FIRSTLEVEL+0,0.764);
     ObjectSetFiboDescription("FiboFanD Complect"+Complect, 0, "38.2 ch");
     
     ObjectSet("FiboFanD Complect"+Complect,OBJPROP_FIRSTLEVEL+1,1.236);
     ObjectSetFiboDescription("FiboFanD Complect"+Complect, 1, "--38.2 ch");
     
     ObjectSet("FiboFanD Complect"+Complect,OBJPROP_FIRSTLEVEL+2,1.0);
     ObjectSetFiboDescription("FiboFanD Complect"+Complect, 2, "0");
//----
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+